using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace DAL
{
    public class UserRepository : IUserRepository, IDisposable
    {
        private Models.DatabaseContex databasecontex;

        public UserRepository(Models.DatabaseContex databasecontex)
        {
            this.databasecontex = databasecontex;
        }

        /// <summary>
        /// متدی برای گرفتن تمامی اسامی کاربران
        /// </summary>
        /// <returns>آبجکت از نوع تو لیست</returns>
        public IEnumerable<Models.User> GetUsers()
        {
            return databasecontex.Users.ToList();
        }

        /// <summary>
        /// متدی برای اضافه کردن 
        /// </summary>
        /// <param name="user"></param>
        public void InsertUser(Models.User user)
        {
            databasecontex.Users.Add(user);
        }


        /// <summary>
        /// متدی برای ذخیره آبجکت های اضافه شده
        /// </summary>
        public void Save()
        {
            databasecontex.SaveChanges();
        }



        private bool disposed = false;

        protected virtual void Dispose(bool disposing)
        {
            if (!this.disposed)
            {
                if (disposing)
                {
                    databasecontex.Dispose();
                }
            }
            this.disposed = true;
        }

        public void Dispose()
        {
            Dispose(true);
            GC.SuppressFinalize(this);
        }



    }
}